<?
/*
TribesQ v0.02.12.09 Example
Tribes 2 Query, Usage Example
Written by Janrex (janrex@hotpop.com)
http://psoft.port5.com

Redirections:
http://psoft.tk
http://psoft.da.ru
http://psoft.tsx.org

Notes:
  -servers' firewall must let through these query packets or else you will get no reply.
  -PHP4 is needed.
  -you may need to use htmlentities() for outputting things such as player name because "<kickass>"
   will not be seen properly as html sees it as a tag, thus the need for converting it to "&lt;kickass&gt;".
  -if you find any bugs in this example, please tell me at janrex@hotpop.com.

Usage:
  -create instance of class: $query = new TTribesQ;
  -set hostname (string): $query->sHost = "192.168.0.1";
  -set port (integer): $query->iPort = 28000;
  -start query: $query->Query();
  -echo the servername: echo $query->Server->Name;
  -the dns reverse lookup can get a dns record but the dns may not actually point to the real ip

History:
  -added tribename prepend and append tags
  -added colouring for alias
*/
$refresh = $_REQUEST['refresh'];
$query = $_REQUEST['query'];
if ($refresh > 1)
  Header ("Refresh: $refresh;tribesqexample.php?query=$query&refresh=$refresh");
include("tribesq.php"); // make sure to include the TTribesQ class
?>
<html>
<head>
<title>tribesqexample.php - TribesQ example</title>
<link href="style.css" type="text/css" rel="stylesheet">
<?
if ($refresh > 1) {
  echo "<script>function set_countdown(){timer = $refresh+1;countdown()}\n";
  echo "function countdown(){timer = timer - 1;if (timer >= 0){test.innerHTML = \"Refreshing in \"+timer+\" seconds\";setTimeout(\"countdown()\",1000);}}</script>\n";
}
?>
</head>
<body <? if ($refresh > 1) echo "onload=\"set_countdown()\"" ?>>
<div align="center">
<h1>Tribes 2 Server Query Example</h1>
<?
//http://([^/:]+):{0,1}(\d*)(\S*)$|))
$exp = "([\.a-z0-9-]{1,}):([0-9]{1,5})$";
if (!eregi($exp,$query,$reg)) // make sure input is valid, doesn't work too well but close enough
{
?>
<table class="maintable"><tr><td align="left">
<form method="POST" action="tribesqexample.php">
<input name="query" type="text"><br>
Example: 192.168.0.1:28000<br><br>
<input name="Query" type="submit" class="out" onmouseover="this.className='over';" onmouseout="this.className='out';" onmousedown="this.className='down';" onmouseup="this.className='over';">
</form>
Try some of these servers:<br>
<a href="tribesqexample.php?query=213.221.176.35:28000">213.221.176.35:28000</a><br>
<a href="tribesqexample.php?query=213.221.176.35:28001">213.221.176.35:28001</a><br>
<a href="tribesqexample.php?query=213.221.176.33:28000">213.221.176.33:28000</a><br>
<a href="tribesqexample.php?query=213.221.176.33:28002">213.221.176.33:28002</a><br>
<a href="tribesqexample.php?query=196.2.33.21:17000">196.2.33.21:17000</a><br>
<a href="tribesqexample.php?query=203.109.252.92:28000">203.109.252.92:28000</a><br>
<a href="tribesqexample.php?query=194.251.249.51:28000">194.251.249.51:28000</a><br>
<a href="tribesqexample.php?query=4.2.12.44:28000">4.2.12.44:28000</a><br>
<a href="tribesqexample.php?query=64.56.37.49:28002">64.56.37.49:28002</a><br>
<a href="tribesqexample.php?query=209.144.205.10:28000">209.144.205.10:28000</a><br>
<a href="tribesqexample.php?query=209.145.148.6:28000">209.145.148.6:28000</a><br>
<a href="tribesqexample.php?query=206.230.220.17:28004">206.230.220.17:28004</a><br>
<a href="tribesqexample.php?query=203.19.226.6:28000">203.19.226.6:28000</a><br>
<a href="tribesqexample.php?query=203.45.146.163:28000">203.45.146.163:28000</a><br>
<a href="tribesqexample.php?query=203.96.152.92:28000">203.96.152.92:28000</a><br>
<a href="tribesqexample.php?query=207.229.179.243:28000">207.229.179.243:28000</a><br>
</td></tr></table>
<?
} else if (eregi($exp,$query,$reg) && $reg[2] > 0 && $reg[2] <= 65535)
  {
  $TribesQ = new TTribesQ;   // create instance of TTribesQ class
  $TribesQ->sHost = $reg[1]; // set hostname eg. "192.168.0.1"
  $TribesQ->iPort = $reg[2]; // set port eg. 28000

  if ($TribesQ->Query(true)) // start query and if successful continue, argument true tells the class to resolve host
  {
    echo "Do another <a href=\"tribesqexample.php\">query</a> | \n";
    echo "Refresh every <a href=\"tribesqexample.php?query=$reg[1]:$reg[2]&refresh=15\">15 seconds</a><br>\n";
    if ($refresh > 1)
      echo "<div id=test></div>\n";
    echo "<br><table width=\"400\">\n";
    echo "<tr><td>Server: </td><td>$query (".$TribesQ->sResolvedHost.")</td></tr>\n";
    echo "<tr><td>Name: </td><td>".$TribesQ->Server->Name."</td></tr>\n";
    echo "<tr><td>Ping: </td><td>".$TribesQ->Server->Ping."ms</td></tr>\n";
    echo "<tr><td>Flags: </td><td>".$TribesQ->Server->Flags."</td></tr>\n";
    //echo "<tr><td>QID1: </td><td>".$TribesQ->Server->QID1."</td></tr>\n";
    //echo "<tr><td>QID2: </td><td>".$TribesQ->Server->QID2."</td></tr>\n";
    echo "<tr><td>QueryVersion: </td><td>".$TribesQ->Server->QueryVersion."</td></tr>\n";
    echo "<tr><td>BuildVersion: </td><td>".$TribesQ->Server->BuildVersion."</td></tr>\n";
    echo "<tr><td>ModName: </td><td>".$TribesQ->Server->ModName."</td></tr>\n";
    echo "<tr><td>MissionType: </td><td>".$TribesQ->Server->MissionType."</td></tr>\n";
    echo "<tr><td>Map: </td><td>".$TribesQ->Server->Map."</td></tr>\n";
    echo "<tr><td>StatusByte: </td><td>".$TribesQ->Server->StatusByte."</td></tr>\n";
    echo "<tr><td>Dedicated: </td><td>".$TribesQ->Server->Status["stDedicated"]."</td></tr>\n";
    echo "<tr><td>Password: </td><td>".$TribesQ->Server->Status["stPassword"]."</td></tr>\n";
    echo "<tr><td>Tournament: </td><td>".$TribesQ->Server->Status["stTournament"]."</td></tr>\n";
    echo "<tr><td>NoAlias: </td><td>".$TribesQ->Server->Status["stNoAlias"]."</td></tr>\n";
    if ($TribesQ->Server->Status["stLinux"])
      echo "<tr><td>OS: </td><td>Linux</td></tr>\n";
    else
      echo "<tr><td>OS: </td><td>Windows</td></tr>\n";
    echo "<tr><td>Players: </td><td>".$TribesQ->Server->NumPlayers."/".$TribesQ->Server->MaxPlayers."</td></tr>\n";
    echo "<tr><td>NumBots: </td><td>".$TribesQ->Server->NumBots."</td></tr>\n";
    echo "<tr><td>CPU: </td><td>".$TribesQ->Server->CPU."MHz</td></tr>\n";
    echo "<tr><td>MinNetProtocol: </td><td>".$TribesQ->Server->MinNetProtocol."</td></tr>\n";
    echo "<tr><td>NetProtocol: </td><td>".$TribesQ->Server->NetProtocol."</td></tr>\n";
    echo "<tr><td>Info: </td><td>".str_replace("\n","<br>",$TribesQ->Server->Info)."</td></tr>\n";
    echo "<tr><td>NoGame: </td><td>".$TribesQ->Server->NoGame."</td></tr>\n";
    if ($TribesQ->Server->NoGame) {
      echo "<tr><td>GameStatus: </td><td>Map Change</td></tr>\n";
      echo "</table>\n";
    } else {
      echo "<tr><td>NumTeams: </td><td>".$TribesQ->Server->NumTeams."</td></tr>\n";
      echo "</table><br>\n";
      echo "<table width=\"400\">\n";
      echo "<tr><th align=\"left\">Team</th><th align=\"left\">Score</th><th align=\"left\">Total Score</th>\n";
      for ($i=0;$i<$TribesQ->Server->NumTeams;$i++) {
        echo "<tr><td>".$TribesQ->Server->TeamName[$i];
        echo "</td><td>".$TribesQ->Server->TeamScore[$i];
        echo "</td><td>".(int)$TribesQ->Server->TeamScoreTotal[$i]."</td></tr>\n";
      }
      echo "</table><br>\n";
      echo "<table width=\"400\">\n";
      echo "<tr><th align=\"left\" width=\"150\">Name&nbsp;&nbsp;</th><th align=\"left\">Score&nbsp;&nbsp;</th><th align=\"left\">Team&nbsp;&nbsp;</th><th align=\"left\">Flags</th></tr>\n";
      for ($i=0;$i<$TribesQ->Server->NumPlayers;$i++) {
        if ($TribesQ->Player[$i]->TribeNameType == 1) { // tribename is prepended
          echo "<tr><td><font id=\"prepend\">".Convert2HTML($TribesQ->Player[$i]->TribeName)."</font><font id=\"normal\">".Convert2HTML($TribesQ->Player[$i]->Name)."</font>";
        } else if ($TribesQ->Player[$i]->TribeNameType == 2) { // tribename is appended
          echo "<tr><td><font id=\"normal\">".Convert2HTML($TribesQ->Player[$i]->Name)."</font><font id=\"append\">".Convert2HTML($TribesQ->Player[$i]->TribeName)."</font>";
        } else if ($TribesQ->Player[$i]->Flags["pfAlias"]) { // alias
          echo "<tr><td><font id=\"alias\">".Convert2HTML($TribesQ->Player[$i]->Name)."</font>";
        } else if ($TribesQ->Player[$i]->Flags["pfBot"]) { // alias
          echo "<tr><td><font id=\"bot\">".Convert2HTML($TribesQ->Player[$i]->Name)."</font>";
        } else { // no tribename
          echo "<tr><td><font id=\"normal\">".Convert2HTML($TribesQ->Player[$i]->Name)."</font>";
        }
        echo "</td><td>".$TribesQ->Player[$i]->Score;
        echo "</td><td>".$TribesQ->Player[$i]->TeamName;
        echo "</td><td>";
        if ($TribesQ->Player[$i]->Flags["pfRegistered"]) echo "Registered ";
        if ($TribesQ->Player[$i]->Flags["pfAlias"]) echo "Alias ";
        if ($TribesQ->Player[$i]->Flags["pfBot"]) echo "Bot ";
        echo "</td></tr>\n";
      }
      echo "</table>";
    }
    echo "<tr><td><br>Received a total of ".strlen($TribesQ->sRaw)." bytes<br>\n";
    if (strlen($TribesQ->sRaw) >= 1500)
      echo "Not all data may have been read as the maximum packet size has been reached.<br>\n";
    if ($TribesQ->DebugInfo) echo $TribesQ->DebugInfo."<br>\n";
    echo "Writing raw to file... ";
    if ($TribesQ->SaveRawToFile("raw.txt")) // file must exist and be chmodded to 666
      echo "Success!</td></tr>\n";
    else
      echo "Failed!</td></tr>\n";
  } else { // query unsuccessful
    echo "Query Unsuccessful.<br>\n";
    if (!eregi($exp, $query, $reg))
      echo "Input seems to be incorrect.<br>\n";
    if ($TribesQ->ErrNo != -1 && $TribesQ->ErrStr != "")
      echo "Error: ".$TribesQ->ErrorNo." - ".$TribesQ->ErrorStr."<br>\n";
  }
  $TribesQ->Destroy(); // destructor
}
?>
</td></tr></table>
</div>
</body>
</html>
